<template>
    <div>
        <div class="uk-child-width-1-2@s uk-grid-divider" uk-grid>
            <div>
                <h4 v-if="!autoriserModificationNom">{{ nomGroupe }}</h4>
                <h4 v-else>
                    <input
                        id="nomClasse"
                        class="uk-input"
                        type="text"
                        placeholder="Entrer un nom"
                        v-model="nomGroupe"
                    />
                </h4>
                <div id="groupeUtilisateur" uk-sortable="group: sortable-group">
                    <UtilisateurClasse
                        v-for="utilisateur in groupe"
                        :key="utilisateur.getId()"
                        :eleve="utilisateur"
                    />
                </div>
            </div>
            <div>
                <h4>{{ nomTotal }}</h4>
                <div id="totalUtilisateur" uk-sortable="group: sortable-group">
                    <UtilisateurClasse
                        v-for="utilisateur in utilisateurs"
                        :key="utilisateur.getId()"
                        :eleve="utilisateur"
                    />
                </div>
            </div>
        </div>
        <button
            @click="enregistrer"
            class="uk-button uk-button-default uk-margin-top"
        >
            Enregistrer
        </button>
    </div>
</template>

<script lang="ts">
import Vue from 'vue';
import Component from 'vue-class-component';
import Axios from '@/auth/axiosAuth';
import UIkit from 'uikit';
import UtilisateurClasse from './UtilisateurListe.vue';
import { Prop } from 'vue-property-decorator';
import UtilisateurSorter from '@/components/outils/UtilisateurSorter';
import Utilisateur from '@/classes/Utilisateur';
@Component({
    components: { UtilisateurClasse }
})
export default class DispatcheurUtilisateur extends Vue {
    @Prop() idGroupe: string;
    @Prop() adresseChargement: string;
    @Prop() adresseEnregistrement: string;
    @Prop() autoriserModificationNom: boolean;
    @Prop() idContenant: string;
    private idElement = '0';
    public nomGroupe = '';
    public nomTotal = '';
    public utilisateurs: Utilisateur[] = [];
    public groupe: any[] = [];

    mounted() {
        this.idElement = this.idElement == '0' ? this.idGroupe : this.idElement;
        const adresse =
            this.idElement == '0'
                ? this.adresseChargement + 'creation/' + this.idContenant
                : this.adresseChargement + this.idElement;
        Axios.get(adresse, response => {
            this.utilisateurs = response.data.utilisateursTotaux.map(json =>
                Object.assign(new Utilisateur(), json)
            );
            UtilisateurSorter.comparerUtilisateurs(this.utilisateurs);
            this.nomGroupe = response.data.nomGroupe;
            this.groupe = response.data.utilisateursGroupe.map(json =>
                Object.assign(new Utilisateur(), json)
            );
            UtilisateurSorter.comparerUtilisateurs(this.groupe);
        });
    }

    public enregistrer() {
        const sortable = UIkit.sortable('#groupeUtilisateur');
        const users = sortable.items
            .map(item => UIkit.util.data(item, 'id'))
            .reduce(function(a, e) {
                a.push(e);
                return a;
            }, []);
        const formData = new FormData();
        if (this.autoriserModificationNom) {
            formData.append('nom', this.nomGroupe);
        }
        formData.append('ids', users);
        if (this.idElement != '0') {
            Axios.put(
                this.adresseEnregistrement + this.idElement,
                response => {
                    UIkit.notification(
                        'Vos modifications ont bien été prises en compte',
                        { status: 'success' }
                    );
                },
                formData
            );
        } else {
            formData.append('id', this.idContenant);
            Axios.put(
                this.adresseEnregistrement,
                response => {
                    this.idElement = response.data.id;
                    UIkit.notification('Votre classe a bien été créée', {
                        status: 'success'
                    });
                },
                formData
            );
        }
    }
}
</script>
